
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>浅谈js中几种实用的跨域方法原理详解_javascript技巧 / iVAN</title>

    <meta name="description" content="浅谈js中几种实用的跨域方法原理详解_javascript技巧 这里说的js跨域是指通过js在不同的域之间进行数据传输或通信,比如用ajax向一个不同的域请求数据,或者通过js获取页面中不同域的框架中(iframe)的数据.只要协议.域名.端口有任何一个不同,都被当作是不同的域. 下表给出了相对http://store.company.com/dir/page.html同源检测的结果: 要解决跨域的问题,我们可以使用以下几种方法: 一.通过jsonp跨域 在js中,我们直接用XMLHttpRequest请求不同域上的数据时,是不可以的.但是,在页面上引入不同">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">浅谈js中几种实用的跨域方法原理详解_javascript技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>这里说的js跨域是指通过js在不同的域之间进行数据传输或通信，比如用ajax向一个不同的域请求数据，或者通过js获取页面中不同域的框架中(iframe)的数据。只要协议、域名、端口有任何一个不同，都被当作是不同的域。</p>
<p>下表给出了相对http://store.company.com/dir/page.html同源检测的结果:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTUyLnBuZw==.jpg"></p>
<p>要解决跨域的问题，我们可以使用以下几种方法：</p>
<p><strong>一、通过jsonp跨域</strong></p>
<p>在js中，我们直接用XMLHttpRequest请求不同域上的数据时，是不可以的。但是，在页面上引入不同域上的js脚本文件却是可以的，jsonp正是利用这个特性来实现的。</p>
<p>比如，有个a.html页面，它里面的代码需要利用ajax获取一个不同域上的json数据，假设这个json数据地址是http://example.com/data.php,那么a.html中的代码就可以这样：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTUzLnBuZw==.jpg"></p>
<p>我们看到获取数据的地址后面还有一个callback参数，按惯例是用这个参数名，但是你用其他的也一样。当然如果获取数据的jsonp地址页面不是你自己能控制的，就得按照提供数据的那一方的规定格式来操作了。</p>
<p>因为是当做一个js文件来引入的，所以http://example.com/data.php返回的必须是一个能执行的js文件，所以这个页面的php代码可能是这样的:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTU0LnBuZw==.jpg"></p>
<p>最终那个页面输出的结果是:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTU1LnBuZw==.jpg"></p>
<p>所以通过http://example.com/data.php?callback=dosomething得到的js文件，就是我们之前定义的dosomething函数,并且它的参数就是我们需要的json数据，这样我们就跨域获得了我们需要的数据。</p>
<p>这样jsonp的原理就很清楚了，通过script标签引入一个js文件，这个js文件载入成功后会执行我们在url参数中指定的函数，并且会把我们需要的json数据作为参数传入。所以jsonp是需要服务器端的页面进行相应的配合的。</p>
<p>知道jsonp跨域的原理后我们就可以用js动态生成script标签来进行跨域操作了，而不用特意的手动的书写那些script标签。如果你的页面使用jquery，那么通过它封装的方法就能很方便的来进行jsonp操作了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTU2LnBuZw==.jpg"></p>
<p>原理是一样的，只不过我们不需要手动的插入script标签以及定义回掉函数。jquery会自动生成一个全局函数来替换callback=?中的问号，之后获取到数据后又会自动销毁，实际上就是起一个临时代理函数的作用。$.getJSON方法会自动判断是否跨域，不跨域的话，就调用普通的ajax方法；跨域的话，则会以异步加载js文件的形式来调用jsonp的回调函数。</p>
<p><strong>2、通过修改document.domain来跨子域</strong></p>
<p>浏览器都有一个同源策略，其限制之一就是第一种方法中我们说的不能通过ajax的方法去请求不同源中的文档。 它的第二个限制是浏览器中不同域的框架之间是不能进行js的交互操作的。有一点需要说明，不同的框架之间（父子或同辈），是能够获取到彼此的window对象的，但蛋疼的是你却不能使用获取到的window对象的属性和方法(html5中的postMessage方法是一个例外，还有些浏览器比如ie6也可以使用top、parent等少数几个属性)，总之，你可以当做是只能获取到一个几乎无用的window对象。比如，有一个页面，它的地址是http://www.example.com/a.html  ， 在这个页面里面有一个iframe，它的src是http://example.com/b.html, 很显然，这个页面与它里面的iframe框架是不同域的，所以我们是无法通过在页面中书写js代码来获取iframe中的东西的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTU3LnBuZw==.jpg"></p>
<p>这个时候，document.domain就可以派上用场了，我们只要把http://www.example.com/a.html 和 http://example.com/b.html这两个页面的document.domain都设成相同的域名就可以了。但要注意的是，document.domain的设置是有限制的，我们只能把document.domain设置成自身或更高一级的父域，且主域必须相同。例如：a.b.example.com 中某个文档的document.domain 可以设成a.b.example.com、b.example.com 、example.com中的任意一个，但是不可以设成 c.a.b.example.com,因为这是当前域的子域，也不可以设成baidu.com,因为主域已经不相同了。</p>
<p>在页面 http://www.example.com/a.html 中设置document.domain:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTU4LnBuZw==.jpg"></p>
<p>在页面 http://example.com/b.html 中也设置document.domain，而且这也是必须的，虽然这个文档的domain就是example.com,但是还是必须显示的设置document.domain的值：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTU5LnBuZw==.jpg"></p>
<p>这样我们就可以通过js访问到iframe中的各种属性和对象了。</p>
<p>不过如果你想在http://www.example.com/a.html 页面中通过ajax直接请求http://example.com/b.html 页面，即使你设置了相同的document.domain也还是不行的，所以修改document.domain的方法只适用于不同子域的框架间的交互。如果你想通过ajax的方法去与不同子域的页面交互，除了使用jsonp的方法外，还可以用一个隐藏的iframe来做一个代理。原理就是让这个iframe载入一个与你想要通过ajax获取数据的目标页面处在相同的域的页面，所以这个iframe中的页面是可以正常使用ajax去获取你要的数据的，然后就是通过我们刚刚讲得修改document.domain的方法，让我们能通过js完全控制这个iframe，这样我们就可以让iframe去发送ajax请求，然后收到的数据我们也可以获得了。</p>
<p><strong>3、使用window.name来进行跨域</strong></p>
<p>window对象有个name属性，该属性有个特征：即在一个窗口(window)的生命周期内,窗口载入的所有的页面都是共享一个window.name的，每个页面对window.name都有读写的权限，window.name是持久存在一个窗口载入过的所有页面中的，并不会因新页面的载入而进行重置。</p>
<p>比如：有一个页面a.html,它里面有这样的代码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTYwLnBuZw==.jpg"></p>
<p>再看看b.html页面的代码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTYxLnBuZw==.jpg"></p>
<p>a.html页面载入后3秒，跳转到了b.html页面，结果为：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2Mzk1OTYyLnBuZw==.jpg"></p>
<p>我们看到在b.html页面上成功获取到了它的上一个页面a.html给window.name设置的值。如果在之后所有载入的页面都没对window.name进行修改的话，那么所有这些页面获取到的window.name的值都是a.html页面设置的那个值。当然，如果有需要，其中的任何一个页面都可以对window.name的值进行修改。注意，window.name的值只能是字符串的形式，这个字符串的大小最大能允许2M左右甚至更大的一个容量，具体取决于不同的浏览器，但一般是够用了。</p>
<p>上面的例子中，我们用到的页面a.html和b.html是处于同一个域的，但是即使a.html与b.html处于不同的域中，上述结论同样是适用的，这也正是利用window.name进行跨域的原理。</p>
<p>下面就来看一看具体是怎么样通过window.name来跨域获取数据的。还是举例说明。</p>
<p>比如有一个www.example.com/a.html页面,需要通过a.html页面里的js来获取另一个位于不同域上的页面www.jb51.net/data.html里的数据。</p>
<p>data.html页面里的代码很简单，就是给当前的window.name设置一个a.html页面想要得到的数据值。data.html里的代码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2NDAwMDYzLnBuZw==.jpg"></p>
<p>那么在a.html页面中，我们怎么把data.html页面载入进来呢？显然我们不能直接在a.html页面中通过改变window.location来载入data.html页面，因为我们想要即使a.html页面不跳转也能得到data.html里的数据。答案就是在a.html页面中使用一个隐藏的iframe来充当一个中间人角色，由iframe去获取data.html的数据，然后a.html再去得到iframe获取到的数据。</p>
<p>充当中间人的iframe想要获取到data.html的通过window.name设置的数据，只需要把这个iframe的src设为www.jb51.net/data.html就行了。然后a.html想要得到iframe所获取到的数据，也就是想要得到iframe的window.name的值，还必须把这个iframe的src设成跟a.html页面同一个域才行，不然根据前面讲的同源策略，a.html是不能访问到iframe里的window.name属性的。这就是整个跨域过程。</p>
<p>看下a.html页面的代码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2NDAwMDY0LnBuZw==.jpg"></p>
<p>上面的代码只是最简单的原理演示代码，你可以对使用js封装上面的过程，比如动态的创建iframe,动态的注册各种事件等等，当然为了安全，获取完数据后，还可以销毁作为代理的iframe。网上也有很多类似的现成代码，有兴趣的可以去找一下。</p>
<p>通过window.name来进行跨域，就是这样子的。</p>
<p><strong> 4、使用HTML5中新引进的window.postMessage方法来跨域传送数据</strong></p>
<p>window.postMessage(message,targetOrigin)  方法是html5新引进的特性，可以使用它来向其它的window对象发送消息，无论这个window对象是属于同源或不同源，目前IE8+、FireFox、Chrome、Opera等浏览器都已经支持window.postMessage方法。</p>
<p>调用postMessage方法的window对象是指要接收消息的那一个window对象，该方法的第一个参数message为要发送的消息，类型只能为字符串；第二个参数targetOrigin用来限定接收消息的那个window对象所在的域，如果不想限定域，可以使用通配符 *  。</p>
<p>需要接收消息的window对象，可是通过监听自身的message事件来获取传过来的消息，消息内容储存在该事件对象的data属性中。</p>
<p>上面所说的向其他window对象发送消息，其实就是指一个页面有几个框架的那种情况，因为每一个框架都有一个window对象。在讨论第二种方法的时候，我们说过，不同域的框架间是可以获取到对方的window对象的，而且也可以使用window.postMessage这个方法。下面看一个简单的示例，有两个页面</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2NDAwMDY1LnBuZw==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2NDAwMDY2LnBuZw==.jpg"></p>
<p>我们运行a页面后得到的结果:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwMjE2NDAwMDY3LnBuZw==.jpg"></p>
<p>我们看到b页面成功的收到了消息。</p>
<p>使用postMessage来跨域传送数据还是比较直观和方便的，但是缺点是IE6、IE7不支持，所以用不用还得根据实际需要来决定。</p>
<p><strong>结语：</strong></p>
<p>除了以上几种方法外，还有flash、在服务器上设置代理页面等跨域方式，这里就不做介绍了。</p>
<p>以上四种方法，可以根据项目的实际情况来进行选择应用，个人认为window.name的方法既不复杂，也能兼容到几乎所有浏览器，这真是极好的一种跨域方法。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 06:40:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/js%e8%b7%a8%e5%9f%9f%e6%96%b9%e6%b3%95/" title="js跨域方法">js跨域方法</a>, <a href="https://www.iamivan.net/tag/%e8%b7%a8%e5%9f%9f%e8%b0%83%e7%94%a8js%e6%96%b9%e6%b3%95/" title="跨域调用js方法">跨域调用js方法</a>, <a href="https://www.iamivan.net/tag/js%e8%b7%a8%e5%9f%9f%e5%8e%9f%e7%90%86/" title="js跨域原理">js跨域原理</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>浅谈js中几种实用的跨域方法原理详解_javascript技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mlx0aYM.html" rel="bookmark">js中几种实用的跨域方法原理详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.这里说的js跨域是指通过js在不同的域之间进行数据传输或通信,比如用ajax向一个不同的域请求数据,或者通过js获取页面中不同域的框架中(iframe)的数据.只要协议.域名.端口有任何一个不同,都被当作是不同的域. (1)下表给出了相对http://store.company.com/dir/page.html同源检测的结果: 要解决跨域的问题,我们可以使用以下几种方法: 一.通过jsonp跨域 在js中,我们直接用XMLHttpRequest请求不同域上的数据时,是不可以的.但是,在页面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QgOnp.html" rel="bookmark">js中跨域方法原理详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				框架中(iframe)的数据.只要协议.域名.端口有任何一个不同,都被当作是不同的域. 下表给出了相对http://store.company.com/dir/page.html同源检测的结果: 要解决跨域的问题,我们可以使用以下几种方法: 一.通过jsonp跨域 在js中,我们直接用XMLHttpRequest请求不同域上的数据时,是不可以的.但是,在页面上引入不同域上的js脚本文件却是可以的,jsonp正是利用这个特性来实现的. 比如,有个a.html页面,它里面的代码需要利用ajax获取一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAEEaZM.html" rel="bookmark">JS JSOP跨域请求实例详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在项目开发中遇到跨域的问题,一般都是通过JSONP来解决的.但是JSONP到底是个什么东西呢,实现的原理又是什么呢.在项目的空闲时间可以好好的来研究一下了. 1.什么是JSONP? 要了解JSONP,不得不提一下JSON,那么什么是JSON? JSON is a subset of the object literal notation of JavaScript. Since JSON is a subset of JavaScript, it can be used in the langu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwgQWvz.html" rel="bookmark">JS中多步骤多分步的StepJump组件实例详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近的工作在做一个多步骤多分步的表单页面,这个多步骤多分步的意思是说这个页面的业务是分多个步骤完成的,每个步骤可能又分多个小步骤来处理,大步骤之间,以及小步骤之间都是一种顺序发生的业务关系.起初以为这种功能很好做,就跟tab页的实现原理差不多,真做下来才发现,这里面的相关逻辑还是挺多的(有可能是我没想到更好地办法~),尤其是当这个功能跟表单,还有业务数据的状态结合起来的时候.我把这个功能相关的一些逻辑抽象成了一个组件StepJump,这个组件能够实现纯静态的分步切换和跳转,以及跟业务相结合的复杂			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYjZ1b.html" rel="bookmark">JS中script标签defer和async属性的区别详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				向html页面中插入javascript代码的主要方法就是通过script标签.其中包括两种形式,第一种直接在script标签之间插入js代码,第二种即是通过src属性引入外部js文件.由于解释器在解析执行js代码期间会阻塞页面其余部分的渲染,对于存在大量js代码的页面来说会导致浏览器出现长时间的空白和延迟,为了避免这个问题,建议把全部的js引用放在&lt;/body&gt;标签之前. script标签存在两个属性,defer和async,因此script标签的使用分为三种情况: 1.&lt;script			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBRjl9b.html" rel="bookmark">浅谈js继承的实现及公有、私有、静态方法的书写&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天没事的时候,研究了一下JS继承的实现,下面是html的源码: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;JS类的继承的实现&lt;/title&gt; &lt;script type=&quot;text/JavaScript&quot;&gt; //定义父类及公有.私有.静态属性及方法 function parent(){ var pname			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQ7w8z.html" rel="bookmark">javascript跨域的4种方法和原理详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下表给出了相对http://store.company.com/dir/page.html同源检测的结果: 要解决跨域的问题,我们可以使用以下几种方法: 一.通过jsonp跨域 在js中,我们直接用XMLHttpRequest请求不同域上的数据时,是不可以的.但是,在页面上引入不同域上的js脚本文件却是可以的,jsonp正是利用这个特性来实现的. 比如,有个a.html页面,它里面的代码需要利用ajax获取一个不同域上的json数据,假设这个json数据地址是http://example.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0N65Jz.html" rel="bookmark">Mvc提交表单的四种方法全程详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一,MVC HtmlHelper方法 1. Html.BeginForm(actionName,controllerName,method,htmlAttributes){} 2. BeginRouteForm 方法 (HtmlHelper, String, Object, FormMethod) 二,传统Form表单Aciton属性提交 三,Jquery+Ajax 提交表单 四,MVC Controller控制器和表单参数传递 MVC HtmlHelper方法 一,Html.BeginForm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWyQ2z.html" rel="bookmark">JavaScript中的splice方法用法详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript中的splice主要用来对js中的数组进行操作,包括删除,添加,替换等. 注意:这种方法会改变原始数组!. 1.删除-用于删除元素,两个参数,第一个参数(要删除第一项的位置),第二个参数(要删除的项数) 2.插入-向数组指定位置插入任意项元素.三个参数,第一个参数(插入位置),第二个参数(0),第三个参数(插入的项) 3.替换-向数组指定位置插入任意项元素,同时删除任意数量的项,三个参数.第一个参数(起始位置),第二个参数(删除的项数),第三个参数(插入任意数量的项) 示例:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyEEvM.html" rel="bookmark" class="title">用户体验价值&colon;细致入微的实施用户体验工作</a>
					<div>
						文章描述:如何衡量用户体验的价值? 苹果凭借不断创新的用户体验重塑了世界上的多个行业:谷歌秉承&quot;以用户为中心,其他一切水到渠成&quot;的理念改变着人们的生活方式:新浪微博在用户体验上借鉴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmgKab.html" rel="bookmark" class="title">ASP中SQL语句导致的性能问题</a>
					<div>
						问题|性能|语句 今天,修改了一点上次做的办公管理系统中的文件上传的BUG,原因是ASP中SQL语句性能问题导致了RecordSet对象关闭,结果使数据入库失败.对于这个错误,我目前只能这样理解了:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2gWoM.html" rel="bookmark" class="title">提高网站权重的四个技巧总结</a>
					<div>
						在网络营销和网站优化方面最重要的就是网站的权重,只要网站有足够的权重一切都不再是问题.那么网站如何才能有权重呢? 今天阿权就把自己的一点看法与诸位分享,有不恰当之处请多多包涵! 第一:网站要想有权重首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEXBLz.html" rel="bookmark" class="title">如何巧妙利用SEO开展网络公关</a>
					<div>
						做网络营销或是SEO的人多少都会意识到,控制对网站或产品信息的负面信息或新闻,对网站进行名誉管理,以及相关的危机处理工作,是SEO所具备的强项之一.利用SEO进行网络公关 ,可以看成是一种对信息的过滤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7GL1M.html" rel="bookmark" class="title">基本数据结构：栈的链式表示</a>
					<div>
						以下为操作栈的算法,该栈为动态栈. 在该栈中,pTop指向的节点中存放该栈的栈顶数据,pBottom指向的节点的上一个节点存放该栈的栈底数据,pBottom指向的节点中不存放有效数据,这样做的目的是为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6d5jz.html" rel="bookmark" class="title">Nginx：一款接管整个网络的俄罗斯软件</a>
					<div>
						据美国&lt;连线&gt;杂志报道,十年多前,一个名不见经传的开源Web服务器软件诞生:十多年后的今天,它的影响力可以同Apache匹敌,吸引全世界一大批网络巨头的加入.他就是俄罗斯的Nginx.那是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKYyap.html" rel="bookmark" class="title">Fireworks Eyecandy滤镜效果</a>
					<div>
						文中的效果需要Eyecandy4.0的支持.如果你对此效果感兴趣,可以下载此滤镜试试. 这是韩国某网站页面的部分截图.有朋友对这个效果很是喜欢,问我怎么做.Fireworks中有edges滤镜,可以制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK3Jrp.html" rel="bookmark" class="title">Merlin的魔力&colon; 用新的正则表达式库解析字符序列</a>
					<div>
						解析模式的文本字符串 正则表达式是根据文本匹配模式的方法 ― 类似于编译器生成类文件的工作原理.编译器在源代码中查找各种模式以便将源代码表达式转换为字节码.通过识别这些源代码模式,编译器能够只将有效的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyvDdb.html" rel="bookmark" class="title">5款中级制作网页的软件</a>
					<div>
						之前笔者介绍过菜鸟级制作网页需要什么软件?我们的技术都在进步,一些菜鸟级的软件已经达不到我们的要求了,我们应该选择哪些制作网页的软件呢?以下5款软件是专门为中级网站制作准备的软件: 相信大家都听说过网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yDV4z.html" rel="bookmark" class="title">利用彩影修复照片拍斜教程</a>
					<div>
						我们经常会由于不小心而拍摄到不少倾斜的照片,原因有很多,可能是手法粗心.手抖又或者是拍摄角度限制所导致的,这样的照片很容易使得画面失去平衡感,总是觉得怪怪的,但是有些照片确实很漂亮或者非常重要,但拍斜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRkqNz.html" rel="bookmark" class="title">盘点10个恶意软件术语</a>
					<div>
						  许多人将恶意软件称为病毒,但从专业的角度讲,这并不准确.你也许听说过许多超出病毒范围的词语:恶意软件.蠕虫病毒.特洛伊木马.根访问权限工具.键盘记录工具.间谍软件等等.那么这些词具体是什么含义呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG725b.html" rel="bookmark" class="title">WPS2012演示中加载的视频不能播放怎么办</a>
					<div>
						  WPS2012演示中加载的视频不能播放,可能是系统中缺少相应的编码程序(XVID即为一种流媒体编码器),下载安装一个XVID解码器即可.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZe16z.html" rel="bookmark" class="title">Excel2010中不能输入斜杠怎么办</a>
					<div>
						  在Excel2010中,无法输入字符:/ ,而是在键盘上按下按键时出现悬浮的快捷键.如下图所示: 方法/步骤 解决办法如下: 打开Excel2010,点击 文件,然后单击&quot;选项&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAmP2M.html" rel="bookmark" class="title">&lbrack;转&rsqb;发布程序时移除Android 调试Log</a>
					<div>
						原文:http://blog.isming.me/blog/2014/06/30/remove-log-in-android/?utm_source=tuicool&amp;utm_medium=re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwrLWM.html" rel="bookmark" class="title">Android UI&rdquo;设计官方教程</a>
					<div>
						我们曾经给大家一个&lt;MeeGo移动终端设备开发UI设计基础教程&gt;,同时很多朋友都在寻找Android UI开发的教程,我们从Android的官方开发者博客找了一份幻灯片,介绍了一些Andr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwER4M.html" rel="bookmark" class="title">编码-为什么我的由swig编译过来的html文件乱码了</a>
					<div>
						问题描述 为什么我的由swig编译过来的html文件乱码了 怎么设置编码?编码都是默认的,没有修改,以前都没碰到这个问题 解决方案 html中读取xml文件中中文出现乱码Qt中显示html文件出现乱码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe5A6b.html" rel="bookmark" class="title">pl sql-oracle 11g 64位plsql登陆问题</a>
					<div>
						问题描述 oracle 11g 64位plsql登陆问题 我用myeclipse创建了web应用并且用jdbc驱动创建数据库连接,兵配置好监听器和tnsname,当我在doc界界面启动数据库和监听器后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeQorb.html" rel="bookmark" class="title">维基解密：梵蒂冈教廷被讽&OpenCurlyDoubleQuote;科技恐惧症&rdquo;</a>
					<div>
						北京时间12月13日下午消息,英国&lt;卫报&gt;公布的维基解密文件显示,美国驻梵蒂冈大使在发给美国国务院(State Department)的电报中称,教皇本笃十六世(Benedictus XV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLlX5p.html" rel="bookmark" class="title">gradle项目转换成maven的pom&period;xml文件</a>
					<div>
						gradle项目转换成maven的pom.xml文件 这是我build.gradle的文件: buildscript { repositories { mavenCentral() } depende ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYao5p.html" rel="bookmark" class="title">求助高手，Appfuse ant 编译问题</a>
					<div>
						问题描述 &lt;sequential&gt;&lt;echo&gt;Compiling@{module}...&lt;/echo&gt;&lt;mkdirdir=&quot;${build.dir} ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLQGaM.html" rel="bookmark" class="title">C&num;用户控件如何相互操作</a>
					<div>
						问题描述 我的窗体布局首先放一个panel在主窗体上,取名panelMain,再向panelMain上添加一个splitContainer,取名splitContainer1,在splitContai ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnOwNM.html" rel="bookmark" class="title">android 网络通信框架volly</a>
					<div>
						1. 什么是Volley 在这之前,我们在程序中需要和网络通信的时候,大体使用的东西莫过于AsyncTaskLoader,HttpURLConnection,AsyncTask,HTTPClient( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWYWrM.html" rel="bookmark" class="title">沃尔玛天天低价的背后：在做整个产业链的整合</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   郎咸平: 在今年6月份的一个零售业论坛上,有一位说道: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QEdRM.html" rel="bookmark" class="title">js批量设置样式的三种方法不推荐使用with&lowbar;javascript技巧</a>
					<div>
						一般我们都用css来批量设置样式,现在我们用js也可以批量设置样式: 总结三种方法如下 复制代码 代码如下: &lt;html&gt; &lt;head&gt; &lt;meta http-equiv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNxR5p.html" rel="bookmark" class="title">java-Android Studio GreenDao使用问题求指导，无法生成Dao文件</a>
					<div>
						问题描述 Android Studio GreenDao使用问题求指导,无法生成Dao文件 我点击运行java文件中的mian方法,速度特别慢,一直无法生成GreenDao所需要的java-gen目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvvXOM.html" rel="bookmark" class="title">美国虚拟主机特大优惠激活双节市场购买力</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 美国虚拟主机历来以高性价比优势享誉全球,如今国庆中秋双节将至,为了抢占这难得的黄金消费市场,各大美国主机商也都集结自身资源优势向用户推出更高性价比的主机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7LX1p.html" rel="bookmark" class="title">WPF Ribbon 开发资料分享</a>
					<div>
						Ribbon 开发工具 WPF Ribbon New 目前微软发布的最新Ribbon 开发工具,上一篇已经做过介绍这里就不再多说了.支持WPF 3.5 SP1.WPF 4,全面兼容VS2010 和Bl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvA8yM.html" rel="bookmark" class="title">中交股份将换股吸收合并路桥建设</a>
					<div>
						路桥建设(600263)3月9日晚间公布了中国交通建设股份有限公司首次公开发行A股暨换股吸收合并路桥建设报告书(草案). 根据草案,中交股份拟首次公开发行A股的同时以换股吸收合并的方式合并路桥建设.本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GDN9M.html" rel="bookmark" class="title">secrets of the javascript Ninja &lpar;Function Prototypes&rpar;&lpar;javascript忍者的秘密&rpar;</a>
					<div>
						       函数原型有很多用途,比如可以用来向一个函数实例上添加一些属性,但是它的一个最主要用途是使JavaScript能够以面向对象的方式编程. 实例化和原型(Instantiation 和 pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBZdkb.html" rel="bookmark" class="title">受制于亚非等地区的经济实力</a>
					<div>
						很多消费者只能购买较为低端的智能手机产品.四年前的Android 2.3比4.0用的人还多近日,谷歌公布了最新一期各版本Android操作系统的分布情况.有一点或许可以让谷歌感到欣慰,目前用户能使用的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
